/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarryhoalg_16;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 *
 * @author majer
 */
public class Graf 
{
    private int aN; // pocet vrcholov
    private int aM; // pocet hran
    private Vrchol[] aVrcholy;
    private Hrana[] aHrany;
    
    public Graf( int paPocetVrcholov, int paPocetHran )
    {
        aN = paPocetVrcholov;
        aM = paPocetHran;
        aVrcholy = new Vrchol[1+aN];
        aHrany = new Hrana[1+aM];
    }
    
    public static Graf nacitajSubor( String paNazovSuboru ) 
            throws FileNotFoundException
    {
        Scanner scanner = new Scanner( new File( paNazovSuboru) );

        int pocetVrcholov = scanner.nextInt();
        int pocetHran = scanner.nextInt();
        Graf g = new Graf(pocetVrcholov, pocetHran);

        for (int i = 1; i <= pocetVrcholov; i++ )
        {
            g.aVrcholy[i] = new Vrchol(i);
        }

        for (int j = 1; j <= pocetHran; j++ )
        {
            int u = scanner.nextInt();
            int v = scanner.nextInt();
            
            g.aHrany[j] = new Hrana( u, v );
        }
        
        return g;
    }
    
    private Hrana najdiHranu( int paU )
    {
        for ( int j = 1; j <= aM; j++ )
        {
            Hrana h = aHrany[j];
            if (h.isHranaPrvehoPrichodu()) continue;
                
            if (h.getU() == paU && 
                    !h.isPouzitaSmeromDoprava())
            {
                return h;
            }
            else if (h.getV() == paU && 
                    !h.isPouzitaSmeromDolava())
            {
                return h;
            }
        }
        
        for ( int j = 1; j <= aM; j++ )
        {
            Hrana h = aHrany[j];
            if (!h.isHranaPrvehoPrichodu()) continue;

            if (h.getU() == paU && 
                    !h.isPouzitaSmeromDoprava())
            {
                return h;
            }
            else if (h.getV() == paU && 
                    !h.isPouzitaSmeromDolava())
            {
                return h;
            }
        }
        
        return null;
    }
    
    public void tarryhoAlg( int paS )
    {
        System.out.println("Tarryho alg. so zaciatkom vo vrchole " + paS);
        
        int u = paS; // aktualny vrchol
        aVrcholy[u].setObjaveny(true);
        
        while(true)
        {
            Hrana h = najdiHranu(u);
            if ( h == null )
            {
                System.out.println("Koniec.");
                break;
            }
            
            // mozem sled predlzit o hranu h
            if ( h.getU() == u )
            {
                // hranu idem pouzit zlava doprava
                System.out.println("Pridavam do sledu hranu "
                    + h + " v smere doprava.");
                h.setPouzitaSmeromDoprava(true);
                u = h.getV();
            }
            else
            {
                // hranu idem pouzit zprava dolava
                System.out.println("Pridavam do sledu hranu "
                    + h + " v smere dolava.");
                h.setPouzitaSmeromDolava(true);
                u = h.getU();
            }
            
            // objavil som novy vrchol?
            if (!aVrcholy[u].isObjaveny())
            {
                aVrcholy[u].setObjaveny(true);
                h.setHranaPrvehoPrichodu(true);
            }
        }
    }
}
